#include <spritepack.h>
#include "constantes.h"
#include "charset.h"
#include "tileset.h"

#pragma output STACKPTR = 24599

void *my_malloc(uint bytes)
{
     return sp_BlockAlloc(0);
}

void *u_malloc = my_malloc;
void *u_free = sp_FreeBlock;


extern uchar *sp_NullSprPtr;
#asm
    LIB SPNullSprPtr
    ._sp_NullSprPtr  defw SPNullSprPtr
#endasm

struct sp_UDK keys;
struct sp_SS *Selector;
extern uchar sel1[], sel2[], sel3[];

extern struct sp_Rect *sp_ClipStruct;
#asm
    LIB SPCClipStruct
    ._sp_ClipStruct
    defw SPCClipStruct
#endasm

extern uchar *sp_KeyStartRepeat;
#asm
XREF SPkeystartrepeat
._sp_KeyStartRepeat     defw SPkeystartrepeat
#endasm


uint asm_int = 0;
uint rand_int = 0;

struct sp_Rect Tablero = {ORIGENGRIDY,ORIGENGRIDX,2 * DIMGRID,2 * DIMGRID}; // Lo definimos como sp_Rect para que los sprites no se carguen el marco


/*

Es CUTRISIMO tener tantas variables globales, pero si vamos a usar la variable en ms de un sitio,
ocupa bastante menos al compilar, porque a las variables globales les asigna tantos bytes como ocupe
el tipo de variable, mientras que con las locales, el compilador, las sube y baja de la pila cada vez
que las usemos, por lo que, si se va a usar bastante la variable, al final compensa por espacio el
hacerla global.

Aqu estn definidas como globales hasta las variables para los bucles... Esto hace que tengamos que
ser hiper cuidadosos al llamar a cada funcin no vaya a ser que la funcin llamada nos modifique las
variables que estamos usando en la funcin que llama.

*/

char TileGrid [DIMGRID * DIMGRID];
uchar XAct, YAct, TX, TY, ObjX, ObjY;
uchar Swaping, FireReleased;
uchar TilesD [7], Objetivo, Doble;
uint Score, HiScore;
uchar Ticks, Segs, Time, TimeIndic, TimeR;
uchar Mode, TileSet, Control, Episode, Locker;
uchar Color, n, m, o, p;
uchar is128k;
uchar CheckEnd;
uint Counter;

uint AddrInterludes[] = {31007, 29816, 28576, 27318, 26205, 31007};

char Cambiante;
void *JoyFunc;

uchar Roll[] = {"A CEZ SILVER GAME MADE BY... CODE:BENWAY   "
                "GRAPHICS:KENDROOCK ANJUEL   SOUND:WYZ AUGUSTORUIZ   "
                "TESTING:IVANZX MANDRAKE METALBRAIN NATHAN TBRAZIL ZEMMAN   "
                "PRODUCTION:KARNEVI   "
                "THANKS TO A. ALBRECHT   DEDICATED TO ELENA & NICOLAS   "
                "(C) 2007 CEZGS"
                "                                ",0};
                
uchar Texts[] = {"AFTER YEARS OF RE-$"
                 "SEARCH,   THE  MAD$"
                 "SCIENTIST DR.CIRI-$"
                 "LUS HAS  FOUND OUT$" 
                 "THE WAY OF GETTING$"
                 "ENERGY   FROM  THE$"
                 "ESSENTIAL CRYSTALS OF THE VIDEO-$"
                 "GAMES.   HELP  HIM  JOINING  THE$"
                 "CRYSTALS BEFORE TIME RUNS OUT,OR$"
                 "BEWARE OF A  DEVASTATING BLAST!!$"
                 "LET'S GO...%"

                 "DR. CIRILUS' SER -$"
                 "VANT,  LOPPO,  HAS$"
                 "THE TASK  OF  CO -$"
                 "LLECTING THE ENER-$"
                 "GY  TO  USE IT  TO$"
                 "CREATE  WEAPONS IN$"
                 "ORDER TO TAKE OVER THE WORLD.$$"
                 "HE WILL  HELP YOU  WITH  SPECIAL$"
                 "CRYSTALS,  BUT NOT EVERYTHING IS$"
                 "WHAT IT SEEMS...%"

                 "PETAZETAS  IS  DR.$"
                 "CIRILUS'   INTERN,$"
                 "AND HE BUILDS RO -$"
                 "BOTS   WITH    THE$"
                 "ENERGY    OF   THE$"
                 "CRYSTALS, BUT EVE-$"
                 "RY  TIME  MORE  COMPLEX JOININGS$"
                 "WITH  MORE CRYSTALS ARE  NEEDED.$"
                 "$"
                 "WILL   YOU   BE   ABLE  TO  HELP$"
                 "HIM OUT?%"

                 "THE ROBOT TERMONIX$"
                 "IS THE  DEFINITIVE$"
                 "WEAPON, WHICH WILL$"
                 "ALLOW  CIRILUS  TO$"
                 "TAKE   OVER    THE$"
                 "UNIVERSE.$$"
                 "THE ENERGY FROM  THE CRYSTALS IS$"
                 "NEEDED  NOW MORE THAN EVER,  BUT$"
                 "IT'S GETTING  TOUGHER TO EXTRACT$"
                 "IT...%"

                 "IN THE GALAXY X32,$"
                 "ALSO KNOW AS MOJO-$"
                 "NIA,   THEY   HAVE$"
                 "FOUND   OUT  ABOUT$"
                 "DR'S    MANEUVERS,$"
                 "AND THEY HAVE SENT$"
                 "A SPECIAL AGENT  TO DESTROY YOUR$"
                 "PLANS: CHARLIE, A VERY DANGEROUS$"
                 "ALIEN.$"
                 "BE  CAREFUL,  FOR HE IS THE ONLY$"
                 "WHO'S ABLE TO STOP YOU!%"

                 "CONGRATULATIONS!!!$"
                 "DR  CIRILUS'  PLAN$"
                 "HAS BEEN SUCCESS -$"
                 "FUL,   THANKS   TO$"
                 "YOUR HELP, AND NOW$"
                 "YOU ARE THE  MAS -$"
                 "TERS OF THE UNIVERSE.$$"
                 "ALL  RACES  AND SPECIES  ARE NOW$"
                 "ENSLAVED AND ASKING FOR MERCY!$"
                 "YOU ARE A REAL PLAYER!!!%"
                 };

uchar GOverTxt[] = {
                 "KAAAABBBBOOOOOMMMM$$"
                 "THE TIME  IS OVER,$"
                 "AND  A  TREMENDOUS$"
                 "BLAST  HAS   DES -$"
                 "TROYED ALL THE LA-$"
                 "BORATORY, AND ALL THE ENERGY YOU$"
                 "HAVE COLLECTED IS NOW LOST.$$"
                 "TRY IT AGAIN,  BUT TRY TO DO  IT$"
                 "FASTER!!!!%"};

uchar CSets[] = {"FACES     BOX II    CEZ HEROESCANNON    JEWELS    "};

#include "sprites.h"
